﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace BufferedGraphicsContext
{
    public partial class Form1 : Form
    {
        private ImagingSolution.Drawing.DoubleBuffer myDoubleBuffer;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // DoubleBufferオブジェクトの作成
            myDoubleBuffer = new ImagingSolution.Drawing.DoubleBuffer(pictureBox1);
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            // リサイズ時は再確保

            if (myDoubleBuffer != null) myDoubleBuffer.Dispose();

            myDoubleBuffer = new ImagingSolution.Drawing.DoubleBuffer(pictureBox1);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            // 解放
            myDoubleBuffer.Dispose();
        }

        private void mnuTest_Click(object sender, EventArgs e)
        {
            // 描画テスト

            int Width = pictureBox1.Width;
            int Height = pictureBox1.Height;

            // Graphicsオブジェクトの取得
            Graphics g = myDoubleBuffer.Graphics;

            Pen p = Pens.Red;

            // 背景の消去
            g.Clear(pictureBox1.BackColor);

            System.Diagnostics.Stopwatch sw = new System.Diagnostics.Stopwatch();

            sw.Start();

            for (int X = 0; X < Width; X += 2){
                g.DrawLine(p, X, 0, X, Height);
            }

            for (int Y = 0; Y < Height; Y += 2)
            {
                g.DrawLine(p, 0, Y, Width, Y);
            }

            // 更新
            myDoubleBuffer.Refresh();

            sw.Stop();

            double time = sw.ElapsedTicks / (double)System.Diagnostics.Stopwatch.Frequency * 1000.0;

            MessageBox.Show("DrawTime = " + time.ToString() + "msec");


        }







    }
}
